var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CPopperContent-org.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React, { useState, useEffect, useRef } from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import { Arrow, Popper as ReactPopper } from 'react-popper';
import { getTarget, targetPropType, mapToCssModules, DOMElement, tagPropType } from './Shared/helper.js';
export var Context = React.createContext({}); //component - CoreUI / CPopperContentWrapper

var CPopperContentWrapper = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CPopperContentWrapper, _React$Component);

  function CPopperContentWrapper() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = CPopperContentWrapper.prototype;

  _proto.getChildContext = function getChildContext() {
    return this.context;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return CPopperContentWrapper;
}(React.Component);

CPopperContentWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired
} : {};
CPopperContentWrapper.contextType = Context;
CPopperContentWrapper.childContextTypes = {
  popperManager: PropTypes.object.isRequired
}; //component - CoreUI / CPopperContent

var CPopperContent = function CPopperContent(props) {
  var _useState = useState(),
      placement = _useState[0],
      setPlacement = _useState[1];

  var fields = useRef({
    firstRender: true
  }).current;

  var setTargetNode = function setTargetNode(node) {
    fields.targetNode = node;
  };

  var getTargetNode = function getTargetNode() {
    return fields.targetNode;
  };

  var getContainerNode = function getContainerNode() {
    return getTarget(props.container);
  };

  var getRef = function getRef(ref) {
    fields._element = ref;
    props.innerRef && props.innerRef();
  };

  var handlePlacementChange = function handlePlacementChange(data) {
    if (placement !== data.placement) {
      setPlacement(data.placement);
    }

    return data;
  }; //effect - update


  useEffect(function () {
    if (fields.firstRender) return;

    if (fields._element && fields._element.childNodes && fields._element.childNodes[0] && fields._element.childNodes[0].focus) {
      fields._element.childNodes[0].focus();
    }
  });
  useEffect(function () {
    fields.firstRender = false;
  }, []); //render

  var renderChildren = function renderChildren() {
    var tag = props.tag,
        children = props.children,
        className = props.className,
        cssModule = props.cssModule,
        flip = props.flip,
        offset = props.offset,
        fallbackPlacement = props.fallbackPlacement,
        placementPrefix = props.placementPrefix,
        _arrowClassName = props.arrowClassName,
        hideArrow = props.hideArrow,
        modifiers = props.modifiers,
        boundariesElement = props.boundariesElement,
        attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "flip", "offset", "fallbackPlacement", "placementPrefix", "arrowClassName", "hideArrow", "modifiers", "boundariesElement"]);

    var arrowClassName = mapToCssModules(classNames('arrow', _arrowClassName), cssModule);
    var placement2 = (placement || attributes.placement).split('-')[0];
    var popperClassName = mapToCssModules(classNames(className, //8 _popperClassName
    placementPrefix ? placementPrefix + "-" + placement2 : placement2), props.cssModule);

    var extendedModifiers = _extends({
      offset: {
        offset: offset
      },
      flip: {
        enabled: flip,
        behavior: fallbackPlacement
      },
      preventOverflow: {
        boundariesElement: boundariesElement
      },
      update: {
        enabled: true,
        order: 950,
        fn: handlePlacementChange
      }
    }, modifiers);

    return /*#__PURE__*/React.createElement(Context.Provider, {
      value: {
        popperManager: {
          setTargetNode: setTargetNode,
          getTargetNode: getTargetNode
        }
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 128,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement(CPopperContentWrapper, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 132,
        columnNumber: 9
      }
    }, /*#__PURE__*/React.createElement(ReactPopper, _extends({
      modifiers: extendedModifiers
    }, attributes, {
      component: tag,
      className: popperClassName,
      "x-placement": placement || attributes.placement,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 133,
        columnNumber: 11
      }
    }), children, !hideArrow && /*#__PURE__*/React.createElement(Arrow, {
      className: arrowClassName,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 141,
        columnNumber: 28
      }
    }))));
  };

  renderChildren.propTypes = process.env.NODE_ENV !== "production" ? {
    tag: tagPropType,
    children: PropTypes.node.isRequired,
    className: PropTypes.string,
    cssModule: PropTypes.object,
    //
    innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
    placement: PropTypes.string,
    placementPrefix: PropTypes.string,
    arrowClassName: PropTypes.string,
    hideArrow: PropTypes.bool,
    show: PropTypes.bool.isRequired,
    offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    fallbackPlacement: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
    flip: PropTypes.bool,
    container: targetPropType,
    target: targetPropType.isRequired,
    modifiers: PropTypes.object,
    boundariesElement: PropTypes.oneOfType([PropTypes.string, DOMElement])
  } : {};
  setTargetNode(getTarget(props.target));

  if (props.show) {
    return props.container === 'inline' ? renderChildren() : ReactDOM.createPortal( /*#__PURE__*/React.createElement("div", {
      ref: getRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 175,
        columnNumber: 30
      }
    }, renderChildren()), getContainerNode());
  }

  return null;
};

CPopperContent.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  placement: PropTypes.string,
  placementPrefix: PropTypes.string,
  arrowClassName: PropTypes.string,
  hideArrow: PropTypes.bool,
  show: PropTypes.bool.isRequired,
  offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  fallbackPlacement: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  flip: PropTypes.bool,
  container: targetPropType,
  target: targetPropType.isRequired,
  modifiers: PropTypes.object,
  boundariesElement: PropTypes.oneOfType([PropTypes.string, DOMElement])
} : {};
CPopperContent.defaultProps = {
  boundariesElement: 'scrollParent',
  placement: 'auto',
  hideArrow: false,
  show: false,
  offset: 0,
  fallbackPlacement: 'flip',
  flip: true,
  container: 'body',
  modifiers: {}
};
export default CPopperContent;