var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CPopperContent.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React, { useState, useEffect, useRef } from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import { Arrow, Popper as ReactPopper } from 'react-popper';
import { getTarget, targetPropType, mapToCssModules, DOMElement, tagPropType } from './Shared/helper.js';
export var Context = React.createContext({}); //component - CoreUI / CPopperContentWrapper
// new popper

var CPopperContentWrapper = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CPopperContentWrapper, _React$Component);

  function CPopperContentWrapper() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = CPopperContentWrapper.prototype;

  _proto.getChildContext = function getChildContext() {
    return this.context;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return CPopperContentWrapper;
}(React.Component);

CPopperContentWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired
} : {};
CPopperContentWrapper.contextType = Context;
CPopperContentWrapper.childContextTypes = {
  popperManager: PropTypes.object.isRequired
}; //component - CoreUI / CPopperContent

var CPopperContent = function CPopperContent(props) {
  var _useState = useState(),
      placement = _useState[0],
      setPlacement = _useState[1];

  var fields = useRef({
    firstRender: true
  }).current;

  var setTargetNode = function setTargetNode(node) {
    fields.targetNode = node;
  };

  var getTargetNode = function getTargetNode() {
    return fields.targetNode;
  };

  var getContainerNode = function getContainerNode() {
    return getTarget(props.container);
  };

  var getRef = function getRef(ref) {
    fields._element = ref;
    props.innerRef && props.innerRef();
  };

  var handlePlacementChange = function handlePlacementChange(data) {
    if (placement !== data.placement) {
      setPlacement(data.placement);
    }

    return data;
  }; //effect - update


  useEffect(function () {
    if (fields.firstRender) return;

    if (fields._element && fields._element.childNodes && fields._element.childNodes[0] && fields._element.childNodes[0].focus) {
      fields._element.childNodes[0].focus();
    }
  });
  useEffect(function () {
    fields.firstRender = false;
  }, []); //render

  var renderChildren = function renderChildren() {
    var tag = props.tag,
        children = props.children,
        className = props.className,
        cssModule = props.cssModule,
        flip = props.flip,
        offset = props.offset,
        fallbackPlacement = props.fallbackPlacement,
        placementPrefix = props.placementPrefix,
        _arrowClassName = props.arrowClassName,
        hideArrow = props.hideArrow,
        modifiers = props.modifiers,
        boundariesElement = props.boundariesElement,
        attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "flip", "offset", "fallbackPlacement", "placementPrefix", "arrowClassName", "hideArrow", "modifiers", "boundariesElement"]);

    var arrowClassName = mapToCssModules(classNames('arrow', _arrowClassName), cssModule);
    var placement2 = (placement || attributes.placement).split('-')[0];
    var popperClassName = mapToCssModules(classNames(className, //8 _popperClassName
    placementPrefix ? placementPrefix + "-" + placement2 : placement2), props.cssModule);

    var extendedModifiers = _extends({
      offset: {
        offset: offset
      },
      flip: {
        enabled: flip,
        behavior: fallbackPlacement
      },
      preventOverflow: {
        boundariesElement: boundariesElement
      },
      update: {
        enabled: true,
        order: 950,
        fn: handlePlacementChange
      }
    }, modifiers);

    return /*#__PURE__*/React.createElement(Context.Provider, {
      value: {
        popperManager: {
          setTargetNode: setTargetNode,
          getTargetNode: getTargetNode
        }
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 126,
        columnNumber: 7
      }
    });
    /*
    https://github.com/popperjs/react-popper
      manager - wrapper, komunikacja
    popper - okno // The Popper component accepts the properties children, placement, modifiers and strategy.
    reference - klikacz
    //
    z createPortal - przenosi
    virtualReferenceElement - gdy przekazujemy referencje
        import { Manager, Reference, Popper } from 'react-popper';
    const Example = () => (
      <Manager>
        <Reference>
          {({ ref }) => (
            <button type="button" ref={ref}>
              Reference element
            </button>
          )}
        </Reference>
        <Popper placement="right">
          {({ ref, style, placement, arrowProps }) => (
            <div ref={ref} style={style} data-placement={placement}>
              Popper element
              <div ref={arrowProps.ref} style={arrowProps.style} />
            </div>
          )}
        </Popper>
      </Manager>
      //
      <Context.Provider value={{popperManager: {
      setTargetNode: setTargetNode,
      getTargetNode: getTargetNode,
    }}}>
      <CPopperContentWrapper>
        <ReactPopper
          modifiers={extendedModifiers}
          {...attributes}
          component={tag}
          className={popperClassName}
          x-placement={placement || attributes.placement}
        >
          {children}
          {!hideArrow && <Arrow className={arrowClassName} />}
        </ReactPopper>
      </CPopperContentWrapper>
    </Context.Provider>
      Core
    info:
    Komponent			{ }					użycie
    CPopperContent		Arrow, Popper			CDropdownCustom, CPopperTargetHelper, CTooltipPopoverWrapper
    <ReactPopper
            modifiers={extendedModifiers}
            {...attributes}
            component={tag}
            className={popperClassName}
            x-placement={placement || attributes.placement}
          >
            {children}
            {!hideArrow && <Arrow className={arrowClassName} />}
        </ReactPopper>
    //
    modifiers = {
      offset: { offset },
      flip: { enabled: flip, behavior: fallbackPlacement },
      preventOverflow: { boundariesElement },
      update: {
        enabled: true,
        order: 950,
        fn: handlePlacementChange,
      },
      ...modifiers,
    };
    CDropdownCustom		Manager				CDropdown, CDropdownItem, CDopdownMenu, CDropdownToggle, CToggler
    <Manager {...attributes} className={classes} onKeyDown={handleKeyDown} ref={reference} />
    CDropdownMenu		Popper				CWidgetSimple
       <Tag
      tabIndex="-1"
      role="menu"
      {...attributes}
      aria-hidden={!context.isOpen}
      className={classes}
      x-placement={attributes.placement}
      ref={innerRef}
     />
    CDropdownToggle		Target				CWidgetSimple
       <Target
      {...attributes}
      className={classes}
      component={Tag}
      onClick={onClick}
      aria-expanded={context.isOpen}
      ref={innerRef}
    >
      {children}
    </Target>
      */
  };

  renderChildren.propTypes = process.env.NODE_ENV !== "production" ? {
    tag: tagPropType,
    children: PropTypes.node.isRequired,
    className: PropTypes.string,
    cssModule: PropTypes.object,
    //
    innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
    placement: PropTypes.string,
    placementPrefix: PropTypes.string,
    arrowClassName: PropTypes.string,
    hideArrow: PropTypes.bool,
    show: PropTypes.bool.isRequired,
    offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    fallbackPlacement: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
    flip: PropTypes.bool,
    container: targetPropType,
    target: targetPropType.isRequired,
    modifiers: PropTypes.object,
    boundariesElement: PropTypes.oneOfType([PropTypes.string, DOMElement])
  } : {};
  setTargetNode(getTarget(props.target));

  if (props.show) {
    return props.container === 'inline' ? renderChildren() : ReactDOM.createPortal( /*#__PURE__*/React.createElement("div", {
      ref: getRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 280,
        columnNumber: 30
      }
    }, renderChildren()), getContainerNode());
  }

  return null;
};

CPopperContent.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  placement: PropTypes.string,
  placementPrefix: PropTypes.string,
  arrowClassName: PropTypes.string,
  hideArrow: PropTypes.bool,
  show: PropTypes.bool.isRequired,
  offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  fallbackPlacement: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  flip: PropTypes.bool,
  container: targetPropType,
  target: targetPropType.isRequired,
  modifiers: PropTypes.object,
  boundariesElement: PropTypes.oneOfType([PropTypes.string, DOMElement])
} : {};
CPopperContent.defaultProps = {
  boundariesElement: 'scrollParent',
  placement: 'auto',
  hideArrow: false,
  show: false,
  offset: 0,
  fallbackPlacement: 'flip',
  flip: true,
  container: 'body',
  modifiers: {}
};
export default CPopperContent;