var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCustomInput.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { mapToCssModules } from './Shared/helper.js'; //component - CoreUI / CCustomInput

var CCustomInput = function CCustomInput(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      label = props.label,
      inline = props.inline,
      valid = props.valid,
      invalid = props.invalid,
      bsSize = props.bsSize,
      wrapperProps = props.wrapperProps,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "cssModule", "innerRef", "label", "inline", "valid", "invalid", "bsSize", "wrapperProps"]); //render


  var type = attributes.type;
  var customClass = mapToCssModules(classNames(className, "custom-" + type, bsSize ? "custom-" + type + "-" + bsSize : false), cssModule);
  var validationClassNames = mapToCssModules(classNames(invalid && 'is-invalid', valid && 'is-valid'), cssModule);

  if (type === 'select') {
    return /*#__PURE__*/React.createElement("select", _extends({}, attributes, {
      className: classNames(validationClassNames, customClass),
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 12
      }
    }), children);
  }

  if (type === 'file') {
    return /*#__PURE__*/React.createElement("div", _extends({
      className: customClass
    }, wrapperProps, {
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 46,
        columnNumber: 7
      }
    }), /*#__PURE__*/React.createElement("input", _extends({}, attributes, {
      className: classNames(validationClassNames, mapToCssModules('custom-file-input', cssModule)),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 47,
        columnNumber: 9
      }
    })), /*#__PURE__*/React.createElement("label", {
      className: mapToCssModules('custom-file-label', cssModule),
      htmlFor: attributes.id,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 9
      }
    }, label || 'Choose file'));
  }

  if (type !== 'checkbox' && type !== 'radio' && type !== 'switch') {
    return /*#__PURE__*/React.createElement("input", _extends({}, attributes, {
      className: classNames(validationClassNames, customClass),
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 12
      }
    }));
  }

  var wrapperClasses = classNames(customClass, mapToCssModules(classNames('custom-control', {
    'custom-control-inline': inline
  }), cssModule));
  return /*#__PURE__*/React.createElement("div", _extends({}, wrapperProps, {
    className: wrapperClasses,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 66,
      columnNumber: 5
    }
  }), /*#__PURE__*/React.createElement("input", _extends({}, attributes, {
    type: type === 'switch' ? 'checkbox' : type,
    className: classNames(validationClassNames, mapToCssModules('custom-control-input', cssModule)),
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 67,
      columnNumber: 7
    }
  })), /*#__PURE__*/React.createElement("label", {
    className: mapToCssModules('custom-control-label', cssModule),
    htmlFor: attributes.id,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 73,
      columnNumber: 7
    }
  }, label), children);
};

CCustomInput.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.oneOfType([PropTypes.node, PropTypes.array, PropTypes.func]),
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  id: PropTypes.oneOfType([PropTypes.string, PropTypes.number]).isRequired,
  type: PropTypes.string.isRequired,
  label: PropTypes.node,
  inline: PropTypes.bool,
  valid: PropTypes.bool,
  invalid: PropTypes.bool,
  bsSize: PropTypes.string,
  wrapperProps: PropTypes.object
} : {};
export default CCustomInput;