var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDropdownCustom.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect, useRef } from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules, omit, keyCodes } from './Shared/helper.js';
import { Manager } from 'react-popper';
export var Context = React.createContext({}); //component - CoreUI / CDropdownCustom

var CDropdownCustom = function CDropdownCustom(props) {
  var _classNames;

  var _omit = omit(props, ['toggle', 'disabled', 'inNavbar', 'direction']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      innerRef = _omit.innerRef,
      show = _omit.show,
      group = _omit.group,
      size = _omit.size,
      inNav = _omit.inNav,
      setActiveFromChild = _omit.setActiveFromChild,
      active = _omit.active,
      addonType = _omit.addonType,
      attributes = _objectWithoutPropertiesLoose(_omit, ["className", "cssModule", "innerRef", "show", "group", "size", "inNav", "setActiveFromChild", "active", "addonType"]);

  var fields = useRef({
    firstRender: true,
    ref: {
      current: null
    }
  }).current;

  var reference = function reference(r) {
    fields.ref.current = r;
    innerRef && innerRef(r);
  };

  var getContainer = function getContainer() {
    if (fields._$container) return fields._$container;
    fields._$container = ReactDOM.findDOMNode(fields.ref.current);
    return fields._$container;
  };

  var getMenuCtrl = function getMenuCtrl() {
    if (fields._$menuCtrl) return fields._$menuCtrl;
    fields._$menuCtrl = getContainer().querySelector('[aria-expanded]');
    return fields._$menuCtrl;
  };

  var getMenuItems = function getMenuItems() {
    return [].slice.call(getContainer().querySelectorAll('[role="menuitem"]'));
  };

  var addEvents = function addEvents() {
    ['click', 'touchstart', 'keyup'].forEach(function (event) {
      return document.addEventListener(event, handleDocumentClick, true);
    });
    fields.handleDocumentClick = handleDocumentClick;
  };

  var removeEvents = function removeEvents() {
    ['click', 'touchstart', 'keyup'].forEach(function (event) {
      return document.removeEventListener(event, fields.handleDocumentClick, true);
    });
  };

  var handleDocumentClick = function handleDocumentClick(e) {
    if (e && (e.which === 3 || e.type === 'keyup' && e.which !== keyCodes.tab)) return;
    var container = getContainer();

    if (container.contains(e.target) && container !== e.target && (e.type !== 'keyup' || e.which === keyCodes.tab)) {
      return;
    }

    toggle(e);
  };

  var handleKeyDown = function handleKeyDown(e) {
    if (/input|textarea/i.test(e.target.tagName) || keyCodes.tab === e.which && e.target.getAttribute('role') !== 'menuitem') {
      return;
    }

    e.preventDefault();
    if (fields.disabled) return;

    if (getMenuCtrl() === e.target) {
      if (!fields.isOpen && [keyCodes.space, keyCodes.enter, keyCodes.up, keyCodes.down].indexOf(e.which) > -1) {
        toggle(e);
        setTimeout(function () {
          return getMenuItems()[0].focus();
        });
      }
    }

    if (fields.isOpen && e.target.getAttribute('role') === 'menuitem') {
      if ([keyCodes.tab, keyCodes.esc].indexOf(e.which) > -1) {
        toggle(e);
        getMenuCtrl().focus();
      } else if ([keyCodes.space, keyCodes.enter].indexOf(e.which) > -1) {
        e.target.click();
        getMenuCtrl().focus();
      } else if ([keyCodes.down, keyCodes.up].indexOf(e.which) > -1 || [keyCodes.n, keyCodes.p].indexOf(e.which) > -1 && e.ctrlKey) {
        var $menuitems = getMenuItems();
        var index = $menuitems.indexOf(e.target);

        if (keyCodes.up === e.which || keyCodes.p === e.which && e.ctrlKey) {
          index = index !== 0 ? index - 1 : $menuitems.length - 1;
        } else if (keyCodes.down === e.which || keyCodes.n === e.which && e.ctrlKey) {
          index = index === $menuitems.length - 1 ? 0 : index + 1;
        }

        $menuitems[index].focus();
      } else if (keyCodes.end === e.which) {
        var _$menuitems = getMenuItems();

        _$menuitems[_$menuitems.length - 1].focus();
      } else if (keyCodes.home === e.which) {
        var _$menuitems2 = getMenuItems();

        _$menuitems2[0].focus();
      } else if (e.which >= 48 && e.which <= 90) {
        var _$menuitems3 = getMenuItems();

        var charPressed = String.fromCharCode(e.which).toLowerCase();

        for (var i = 0; i < _$menuitems3.length; i += 1) {
          var firstLetter = _$menuitems3[i].textContent && _$menuitems3[i].textContent[0].toLowerCase();

          if (firstLetter === charPressed) {
            _$menuitems3[i].focus();

            break;
          }
        }
      }
    }
  };

  var handleProps = function handleProps() {
    if (props.show) {
      addEvents();
    } else {
      removeEvents();
    }
  };

  var toggle = function toggle(e) {
    if (fields.disabled) {
      return e && e.preventDefault();
    }

    return props.toggle(e);
  }; //effect


  useEffect(function () {
    if (fields.firstRender) {
      return;
    }

    handleProps();
  }, [props.show]);
  useEffect(function () {
    fields.firstRender = false;
    handleProps();
    return function cleanup() {
      removeEvents();
    };
  }, []); //render

  fields.disabled = props.disabled;
  fields.isOpen = props.show;
  var direction = props.direction; //(props.direction === 'down' && dropup) ? 'up' :
  //attributes.tag

  var Tag = attributes.tag || (inNav ? 'li' : 'div');
  var subItemIsActive = false;

  if (setActiveFromChild) {
    React.Children.map(props.children[1].props.children, function (dropdownItem) {
      if (dropdownItem && dropdownItem.props.active) subItemIsActive = true;
    });
  }

  var classes = mapToCssModules(classNames(className, direction !== 'down' && "drop" + direction, inNav && active ? 'active' : false, setActiveFromChild && subItemIsActive ? 'active' : false, (_classNames = {}, _classNames["input-group-" + addonType] = addonType, _classNames['btn-group'] = group, _classNames["btn-group-" + size] = !!size, _classNames['dropdown'] = !group && !addonType, _classNames['show'] = show, _classNames['nav-item'] = inNav, _classNames)), cssModule);
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      toggle: props.toggle,
      isOpen: props.show,
      direction: props.direction,
      //(props.direction === 'down' && props.dropup) ? 'up' :
      inNavbar: props.inNavbar
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 202,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
    className: classes,
    onKeyDown: handleKeyDown,
    ref: reference,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 208,
      columnNumber: 7
    }
  }), /*#__PURE__*/React.createElement(Manager, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 214,
      columnNumber: 9
    }
  }, props.children)));
};

CDropdownCustom.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  direction: PropTypes.oneOf(['up', 'down', 'left', 'right']),
  group: PropTypes.bool,
  show: PropTypes.bool,
  disabled: PropTypes.bool,
  active: PropTypes.bool,
  addonType: PropTypes.oneOfType([PropTypes.bool, PropTypes.oneOf(['prepend', 'append'])]),
  size: PropTypes.string,
  toggle: PropTypes.func,
  inNav: PropTypes.bool,
  inNavbar: PropTypes.bool,
  setActiveFromChild: PropTypes.bool
} : {};
CDropdownCustom.defaultProps = {
  show: false,
  direction: 'down',
  active: false,
  addonType: false,
  inNav: false,
  inNavbar: false,
  setActiveFromChild: false,
  group: true
};
export default CDropdownCustom;