var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDropdownMenu.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useContext } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import { Popper } from 'react-popper';
import { Context } from './CDropdownCustom'; //component - CoreUI / CDropdownMenu

var CDropdownMenu = function CDropdownMenu(props) {
  var className = props.className,
      children = props.children,
      cssModule = props.cssModule,
      right = props.right,
      tag = props.tag,
      flip = props.flip,
      modifiers = props.modifiers,
      persist = props.persist,
      innerRef = props.innerRef,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "children", "cssModule", "right", "tag", "flip", "modifiers", "persist", "innerRef"]);

  var noFlipModifier = {
    flip: {
      enabled: false
    }
  };
  var directionPositionMap = {
    up: 'top',
    left: 'left',
    right: 'right',
    down: 'bottom'
  };
  var context = useContext(Context); //render

  var classes = mapToCssModules(classNames(className, 'dropdown-menu', {
    'dropdown-menu-right': right,
    'show': context.isOpen
  }), cssModule);
  var Tag = tag;
  var placement;
  var myModifiers = modifiers;

  if (persist || context.isOpen && !context.inNavbar) {
    Tag = Popper;
    var position1 = directionPositionMap[context.direction] || 'bottom';
    var position2 = right ? 'end' : 'start';
    placement = position1 + "-" + position2; //attributes.component = tag;

    myModifiers = !flip ? _extends({}, modifiers, {}, noFlipModifier) : modifiers;
    /*
    x-placement={attributes.placement}
    */

    return /*#__PURE__*/React.createElement(Tag, {
      placement: placement,
      modifiers: myModifiers,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 66,
        columnNumber: 7
      }
    }, function (_ref) {
      var ref = _ref.ref,
          style = _ref.style,
          placement = _ref.placement,
          arrowProps = _ref.arrowProps;
      //console.log(style, children);
      return /*#__PURE__*/React.createElement("div", _extends({}, attributes, {
        tabIndex: "-1",
        role: "menu",
        "aria-hidden": !context.isOpen,
        className: classes,
        ref: innerRef,
        "data-placement": placement,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 73,
          columnNumber: 13
        }
      }), children);
    });
  }

  return /*#__PURE__*/React.createElement(Tag, _extends({
    tabIndex: "-1",
    role: "menu"
  }, attributes, {
    "aria-hidden": !context.isOpen,
    className: classes,
    "x-placement": attributes.placement,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 93,
      columnNumber: 5
    }
  }), children);
};

CDropdownMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node.isRequired,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  right: PropTypes.bool,
  flip: PropTypes.bool,
  modifiers: PropTypes.object,
  persist: PropTypes.bool
} : {};
CDropdownMenu.defaultProps = {
  tag: 'div',
  flip: true
};
export default CDropdownMenu;