"use strict";

exports.__esModule = true;
exports["default"] = exports.Context = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _reactPopper = require("react-popper");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CDropdownCustom-org.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var Context = _react["default"].createContext({}); //component - CoreUI / CPopperContentWrapper


exports.Context = Context;

var CPopperContentWrapper = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CPopperContentWrapper, _React$Component);

  function CPopperContentWrapper() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = CPopperContentWrapper.prototype;

  _proto.getChildContext = function getChildContext() {
    return this.context;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return CPopperContentWrapper;
}(_react["default"].Component);

CPopperContentWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node
} : {};
CPopperContentWrapper.contextType = Context;
CPopperContentWrapper.childContextTypes = {
  toggle: _propTypes["default"].func.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  direction: _propTypes["default"].oneOf(['up', 'down', 'left', 'right']).isRequired,
  inNavbar: _propTypes["default"].bool.isRequired
}; //component - CoreUI / CDropdownCustom

var CDropdownCustom = function CDropdownCustom(props) {
  var _classNames;

  var _omit = (0, _helper.omit)(props, ['toggle', 'disabled', 'inNavbar', 'direction']),
      className = _omit.className,
      cssModule = _omit.cssModule,
      innerRef = _omit.innerRef,
      show = _omit.show,
      group = _omit.group,
      size = _omit.size,
      inNav = _omit.inNav,
      setActiveFromChild = _omit.setActiveFromChild,
      active = _omit.active,
      addonType = _omit.addonType,
      attributes = _objectWithoutPropertiesLoose(_omit, ["className", "cssModule", "innerRef", "show", "group", "size", "inNav", "setActiveFromChild", "active", "addonType"]);

  var fields = (0, _react.useRef)({
    firstRender: true,
    ref: {
      current: null
    }
  }).current;

  var reference = function reference(r) {
    fields.ref.current = r;
    innerRef && innerRef(r);
  };

  var getContainer = function getContainer() {
    if (fields._$container) return fields._$container;
    fields._$container = _reactDom["default"].findDOMNode(fields.ref.current);
    return fields._$container;
  };

  var getMenuCtrl = function getMenuCtrl() {
    if (fields._$menuCtrl) return fields._$menuCtrl;
    fields._$menuCtrl = getContainer().querySelector('[aria-expanded]');
    return fields._$menuCtrl;
  };

  var getMenuItems = function getMenuItems() {
    return [].slice.call(getContainer().querySelectorAll('[role="menuitem"]'));
  };

  var addEvents = function addEvents() {
    ['click', 'touchstart', 'keyup'].forEach(function (event) {
      return document.addEventListener(event, handleDocumentClick, true);
    });
    fields.handleDocumentClick = handleDocumentClick;
  };

  var removeEvents = function removeEvents() {
    ['click', 'touchstart', 'keyup'].forEach(function (event) {
      return document.removeEventListener(event, fields.handleDocumentClick, true);
    });
  };

  var handleDocumentClick = function handleDocumentClick(e) {
    if (e && (e.which === 3 || e.type === 'keyup' && e.which !== _helper.keyCodes.tab)) return;
    var container = getContainer();

    if (container.contains(e.target) && container !== e.target && (e.type !== 'keyup' || e.which === _helper.keyCodes.tab)) {
      return;
    }

    toggle(e);
  };

  var handleKeyDown = function handleKeyDown(e) {
    if (/input|textarea/i.test(e.target.tagName) || _helper.keyCodes.tab === e.which && e.target.getAttribute('role') !== 'menuitem') {
      return;
    }

    e.preventDefault();
    if (fields.disabled) return;

    if (getMenuCtrl() === e.target) {
      if (!fields.isOpen && [_helper.keyCodes.space, _helper.keyCodes.enter, _helper.keyCodes.up, _helper.keyCodes.down].indexOf(e.which) > -1) {
        toggle(e);
        setTimeout(function () {
          return getMenuItems()[0].focus();
        });
      }
    }

    if (fields.isOpen && e.target.getAttribute('role') === 'menuitem') {
      if ([_helper.keyCodes.tab, _helper.keyCodes.esc].indexOf(e.which) > -1) {
        toggle(e);
        getMenuCtrl().focus();
      } else if ([_helper.keyCodes.space, _helper.keyCodes.enter].indexOf(e.which) > -1) {
        e.target.click();
        getMenuCtrl().focus();
      } else if ([_helper.keyCodes.down, _helper.keyCodes.up].indexOf(e.which) > -1 || [_helper.keyCodes.n, _helper.keyCodes.p].indexOf(e.which) > -1 && e.ctrlKey) {
        var $menuitems = getMenuItems();
        var index = $menuitems.indexOf(e.target);

        if (_helper.keyCodes.up === e.which || _helper.keyCodes.p === e.which && e.ctrlKey) {
          index = index !== 0 ? index - 1 : $menuitems.length - 1;
        } else if (_helper.keyCodes.down === e.which || _helper.keyCodes.n === e.which && e.ctrlKey) {
          index = index === $menuitems.length - 1 ? 0 : index + 1;
        }

        $menuitems[index].focus();
      } else if (_helper.keyCodes.end === e.which) {
        var _$menuitems = getMenuItems();

        _$menuitems[_$menuitems.length - 1].focus();
      } else if (_helper.keyCodes.home === e.which) {
        var _$menuitems2 = getMenuItems();

        _$menuitems2[0].focus();
      } else if (e.which >= 48 && e.which <= 90) {
        var _$menuitems3 = getMenuItems();

        var charPressed = String.fromCharCode(e.which).toLowerCase();

        for (var i = 0; i < _$menuitems3.length; i += 1) {
          var firstLetter = _$menuitems3[i].textContent && _$menuitems3[i].textContent[0].toLowerCase();

          if (firstLetter === charPressed) {
            _$menuitems3[i].focus();

            break;
          }
        }
      }
    }
  };

  var handleProps = function handleProps() {
    if (props.show) {
      addEvents();
    } else {
      removeEvents();
    }
  };

  var toggle = function toggle(e) {
    if (fields.disabled) {
      return e && e.preventDefault();
    }

    return props.toggle(e);
  }; //effect


  (0, _react.useEffect)(function () {
    if (fields.firstRender) {
      return;
    }

    handleProps();
  }, [props.show]);
  (0, _react.useEffect)(function () {
    fields.firstRender = false;
    handleProps();
    return function cleanup() {
      removeEvents();
    };
  }, []); //render

  fields.disabled = props.disabled;
  fields.isOpen = props.show;
  var direction = props.direction; //(props.direction === 'down' && dropup) ? 'up' :

  attributes.tag = attributes.tag || (inNav ? 'li' : 'div');
  var subItemIsActive = false;

  if (setActiveFromChild) {
    _react["default"].Children.map(props.children[1].props.children, function (dropdownItem) {
      if (dropdownItem && dropdownItem.props.active) subItemIsActive = true;
    });
  }

  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, direction !== 'down' && "drop" + direction, inNav && active ? 'active' : false, setActiveFromChild && subItemIsActive ? 'active' : false, (_classNames = {}, _classNames["input-group-" + addonType] = addonType, _classNames['btn-group'] = group, _classNames["btn-group-" + size] = !!size, _classNames['dropdown'] = !group && !addonType, _classNames['show'] = show, _classNames['nav-item'] = inNav, _classNames)), cssModule);
  return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
    value: {
      toggle: props.toggle,
      isOpen: props.show,
      direction: props.direction,
      //(props.direction === 'down' && props.dropup) ? 'up' :
      inNavbar: props.inNavbar
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 225,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(CPopperContentWrapper, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 231,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactPopper.Manager, _extends({}, attributes, {
    className: classes,
    onKeyDown: handleKeyDown,
    ref: reference,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 232,
      columnNumber: 9
    }
  }))));
};

CDropdownCustom.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  direction: _propTypes["default"].oneOf(['up', 'down', 'left', 'right']),
  group: _propTypes["default"].bool,
  show: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  active: _propTypes["default"].bool,
  addonType: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].oneOf(['prepend', 'append'])]),
  size: _propTypes["default"].string,
  toggle: _propTypes["default"].func,
  inNav: _propTypes["default"].bool,
  inNavbar: _propTypes["default"].bool,
  setActiveFromChild: _propTypes["default"].bool
} : {};
CDropdownCustom.defaultProps = {
  show: false,
  direction: 'down',
  active: false,
  addonType: false,
  inNav: false,
  inNavbar: false,
  setActiveFromChild: false,
  group: true
};
var _default = CDropdownCustom;
exports["default"] = _default;