"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _reactPopper = require("react-popper");

var _CButton = _interopRequireDefault(require("./CButton"));

var _CDropdownCustom = require("./CDropdownCustom");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CDropdownToggle-org.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CDropdownToggle
var CDropdownToggle = function CDropdownToggle(props) {
  var className = props.className,
      color = props.color,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      caret = props.caret,
      split = props.split,
      nav = props.nav,
      header = props.header,
      tag = props.tag,
      togglerHtml = props.togglerHtml,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "color", "cssModule", "innerRef", "caret", "split", "nav", "header", "tag", "togglerHtml"]);

  var context = (0, _react.useContext)(_CDropdownCustom.Context);

  var onClick = function onClick(e) {
    if (props.disabled) {
      e.preventDefault();
      return;
    }

    if (props.nav && !props.tag) {
      e.preventDefault();
    }

    if (props.onClick) {
      props.onClick(e);
    }

    context.toggle(e);
  }; //render


  var ariaLabel = attributes['aria-label'] || 'Toggle Dropdown';
  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, {
    'dropdown-toggle': caret || split,
    'dropdown-toggle-split': split,
    'nav-link': nav && !header,
    'c-header-nav-link': nav && header
  }), cssModule);

  var children = togglerHtml || attributes.children || /*#__PURE__*/_react["default"].createElement("span", {
    className: "sr-only",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 58,
      columnNumber: 58
    }
  }, ariaLabel);

  var Tag;
  var isButton = false;

  if (nav && !tag) {
    Tag = 'a';
    attributes.href = '#';
  } else if (!tag) {
    Tag = _CButton["default"];
    attributes.color = color;
    attributes.cssModule = cssModule;
    isButton = true;
  } else {
    Tag = tag;
  }

  if (context.inNavbar) {
    if (isButton) return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      onClick: onClick,
      "aria-expanded": context.isOpen,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 78,
        columnNumber: 9
      }
    }), children);else return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      onClick: onClick,
      "aria-expanded": context.isOpen,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 89,
        columnNumber: 9
      }
    }), children);
  }

  return /*#__PURE__*/_react["default"].createElement(_reactPopper.Target, _extends({}, attributes, {
    className: classes,
    component: Tag,
    onClick: onClick,
    "aria-expanded": context.isOpen,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 102,
      columnNumber: 5
    }
  }), children);
};

CDropdownToggle.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  caret: _propTypes["default"].bool,
  color: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  'aria-haspopup': _propTypes["default"].bool,
  split: _propTypes["default"].bool,
  togglerHtml: _propTypes["default"].node,
  nav: _propTypes["default"].bool,
  header: _propTypes["default"].bool
} : {};
CDropdownToggle.defaultProps = {
  'aria-haspopup': true
};
var _default = CDropdownToggle;
exports["default"] = _default;
module.exports = exports.default;