"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CPopperContent = _interopRequireDefault(require("./CPopperContent"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CTooltipPopoverWrapper-org.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// global
var DEFAULT_DELAYS = {
  show: 0,
  hide: 250
};

var isInDOMSubtree = function isInDOMSubtree(element, subtreeRoot) {
  return subtreeRoot && (element === subtreeRoot || subtreeRoot.contains(element));
}; //component - CoreUI / CTooltipPopoverWrapper


var CTooltipPopoverWrapper = function CTooltipPopoverWrapper(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerClassName = props.innerClassName,
      target = props.target,
      isOpen = props.show,
      hideArrow = props.hideArrow,
      boundariesElement = props.boundariesElement,
      placement = props.placement,
      placementPrefix = props.placementPrefix,
      arrowClassName = props.arrowClassName,
      container = props.container,
      modifiers = props.modifiers,
      offset = props.offset;
  var fields = (0, _react.useRef)({
    _target: null
  }).current;

  var onMouseOverTooltipContent = function onMouseOverTooltipContent() {
    if (fields.trigger.indexOf('hover') > -1 && !fields.autohide) {
      if (fields._hideTimeout) {
        clearHideTimeout();
      }
    }
  };

  var onMouseLeaveTooltipContent = function onMouseLeaveTooltipContent(e) {
    if (fields.trigger.indexOf('hover') > -1 && !fields.autohide) {
      if (fields._showTimeout) {
        clearShowTimeout();
      }

      e.persist();
      fields._hideTimeout = setTimeout(function () {
        return hide(e);
      }, getDelay('hide'));
    }
  };

  var onEscKeyDown = function onEscKeyDown(e) {
    if (e.key === 'Escape') {
      hide(e);
    }
  };

  var getRef = function getRef(ref) {
    var innerRef = props.innerRef;

    if (innerRef) {
      if (typeof innerRef === 'function') {
        innerRef(ref);
      } else if (typeof innerRef === 'object') {
        innerRef.current = ref;
      }
    }

    fields._popover = ref;
  };

  var getDelay = function getDelay(key) {
    if (typeof fields.delay === 'object') {
      return isNaN(fields.delay[key]) ? DEFAULT_DELAYS[key] : fields.delay[key];
    }

    return fields.delay;
  };

  var show = function show(e) {
    if (!fields.isOpen) {
      clearShowTimeout();
      toggle(e);
    }
  };

  var showWithDelay = function showWithDelay(e) {
    if (fields._hideTimeout) {
      clearHideTimeout();
    }

    fields._showTimeout = setTimeout(function () {
      return show(e);
    }, getDelay('show'));
  };

  var hide = function hide(e) {
    if (fields.isOpen) {
      clearHideTimeout();
      toggle(e);
    }
  };

  var hideWithDelay = function hideWithDelay(e) {
    if (fields._showTimeout) {
      clearShowTimeout();
    }

    fields._hideTimeout = setTimeout(function () {
      return hide(e);
    }, getDelay('hide'));
  };

  var clearShowTimeout = function clearShowTimeout() {
    clearTimeout(fields._showTimeout);
    fields._showTimeout = undefined;
  };

  var clearHideTimeout = function clearHideTimeout() {
    clearTimeout(fields._hideTimeout);
    fields._hideTimeout = undefined;
  };

  var handleDocumentClick = function handleDocumentClick(e) {
    var triggers = fields.trigger.split(' ');

    if (triggers.indexOf('legacy') > -1 && (fields.isOpen || isInDOMSubtree(e.target, fields._target))) {
      if (fields._hideTimeout) {
        clearHideTimeout();
      }

      if (fields.isOpen && !isInDOMSubtree(e.target, fields._popover)) {
        hideWithDelay(e);
      } else {
        showWithDelay(e);
      }
    } else if (triggers.indexOf('click') > -1 && isInDOMSubtree(e.target, fields._target)) {
      if (fields._hideTimeout) {
        clearHideTimeout();
      }

      if (!fields.isOpen) {
        showWithDelay(e);
      } else {
        hideWithDelay(e);
      }
    }
  };

  var addTargetEvents = function addTargetEvents() {
    if (props.trigger) {
      var triggers = props.trigger.split(' ');

      if (triggers.indexOf('manual') === -1) {
        if (triggers.indexOf('click') > -1 || triggers.indexOf('legacy') > -1) {
          ['click', 'touchstart'].forEach(function (event) {
            return document.addEventListener(event, handleDocumentClick, true);
          });
          fields._handleDocumentClick = handleDocumentClick;
        }

        if (fields._target) {
          if (triggers.indexOf('hover') > -1) {
            fields._target.addEventListener('mouseover', showWithDelay, true);

            fields._target.addEventListener('mouseout', hideWithDelay, true);

            fields._showWithDelay = showWithDelay;
            fields._hideWithDelay = hideWithDelay;
          }

          if (triggers.indexOf('focus') > -1) {
            fields._target.addEventListener('focusin', show, true);

            fields._target.addEventListener('focusout', hide, true);

            fields._show = show;
            fields._hide = hide;
          }

          fields._target.addEventListener('keydown', onEscKeyDown, true);

          fields._onEscKeyDown = onEscKeyDown;
        }
      }
    }
  };

  var removeTargetEvents = function removeTargetEvents() {
    if (fields._target) {
      fields._target.removeEventListener('mouseover', fields._showWithDelay, true);

      fields._target.removeEventListener('mouseout', fields._hideWithDelay, true);

      fields._target.removeEventListener('keydown', fields._onEscKeyDown, true);

      fields._target.removeEventListener('focusin', fields._show, true);

      fields._target.removeEventListener('focusout', fields._hide, true);
    }

    ['click', 'touchstart'].forEach(function (event) {
      return document.removeEventListener(event, fields._handleDocumentClick, true);
    });
  };

  var updateTarget = function updateTarget() {
    var newTarget = (0, _helper.getTarget)(props.target);

    if (newTarget !== fields._target) {
      removeTargetEvents();
      fields._target = newTarget;
      addTargetEvents();
    }
  };

  var toggle = function toggle(e) {
    if (fields.disabled) {
      return e && e.preventDefault();
    }

    return fields.toggle(e);
  }; //effect


  (0, _react.useEffect)(function () {
    updateTarget();
    return function cleanup() {
      removeTargetEvents();
    };
  }, []); //render

  fields.isOpen = props.show;
  fields.autohide = props.autohide;
  fields.trigger = props.trigger;
  fields.delay = props.delay;
  fields.toggle = props.toggle;
  fields.disabled = props.disabled;

  if (!props.show) {
    return null;
  }

  updateTarget();
  var attributes = (0, _helper.omit)(props, Object.keys(CTooltipPopoverWrapper.propTypes));
  var popperClasses = (0, _helper.mapToCssModules)(className, cssModule);
  var classes = (0, _helper.mapToCssModules)(innerClassName, cssModule);
  return /*#__PURE__*/_react["default"].createElement(_CPopperContent["default"], {
    className: popperClasses,
    target: target,
    show: isOpen,
    hideArrow: hideArrow,
    boundariesElement: boundariesElement,
    placement: placement,
    placementPrefix: placementPrefix,
    arrowClassName: arrowClassName,
    container: container,
    modifiers: modifiers,
    offset: offset,
    cssModule: cssModule,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 271,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement("div", _extends({}, attributes, {
    className: classes,
    role: "tooltip",
    "aria-hidden": isOpen,
    onMouseOver: onMouseOverTooltipContent,
    onMouseLeave: onMouseLeaveTooltipContent,
    onKeyDown: onEscKeyDown,
    ref: getRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 285,
      columnNumber: 7
    }
  })));
};

CTooltipPopoverWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  placement: _propTypes["default"].oneOf(_helper.PopperPlacements),
  target: _helper.targetPropType.isRequired,
  container: _helper.targetPropType,
  show: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  hideArrow: _propTypes["default"].bool,
  boundariesElement: _propTypes["default"].oneOfType([_propTypes["default"].string, _helper.DOMElement]),
  innerClassName: _propTypes["default"].string,
  arrowClassName: _propTypes["default"].string,
  toggle: _propTypes["default"].func,
  autohide: _propTypes["default"].bool,
  placementPrefix: _propTypes["default"].string,
  delay: _propTypes["default"].oneOfType([_propTypes["default"].shape({
    show: _propTypes["default"].number,
    hide: _propTypes["default"].number
  }), _propTypes["default"].number]),
  modifiers: _propTypes["default"].object,
  offset: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  trigger: _propTypes["default"].string
} : {};
CTooltipPopoverWrapper.defaultProps = {
  show: false,
  hideArrow: false,
  autohide: false,
  delay: DEFAULT_DELAYS,
  toggle: function toggle() {},
  trigger: 'click'
};
var _default = CTooltipPopoverWrapper;
exports["default"] = _default;
module.exports = exports.default;