"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactPopper = require("react-popper");

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CTooltipPopoverWrapper.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// global
var DEFAULT_DELAYS = {
  show: 0,
  hide: 250
};

var isInDOMSubtree = function isInDOMSubtree(element, subtreeRoot) {
  return subtreeRoot && (element === subtreeRoot || subtreeRoot.contains(element));
}; //component - CoreUI / CTooltipPopoverWrapper


var CTooltipPopoverWrapper = function CTooltipPopoverWrapper(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerClassName = props.innerClassName,
      target = props.target,
      isOpen = props.show,
      hideArrow = props.hideArrow,
      boundariesElement = props.boundariesElement,
      placement = props.placement,
      placementPrefix = props.placementPrefix,
      arrowClassName = props.arrowClassName,
      container = props.container,
      modifiers = props.modifiers,
      offset = props.offset,
      reference = props.reference,
      children = props.children;
  return /*#__PURE__*/_react["default"].createElement(_reactPopper.Manager, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactPopper.Reference, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 7
    }
  }, reference), /*#__PURE__*/_react["default"].createElement(_reactPopper.Popper, {
    placement: placement,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 58,
      columnNumber: 7
    }
  }, children));
};

CTooltipPopoverWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  placement: _propTypes["default"].oneOf(_helper.PopperPlacements),
  target: _helper.targetPropType.isRequired,
  container: _helper.targetPropType,
  show: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  hideArrow: _propTypes["default"].bool,
  boundariesElement: _propTypes["default"].oneOfType([_propTypes["default"].string, _helper.DOMElement]),
  innerClassName: _propTypes["default"].string,
  arrowClassName: _propTypes["default"].string,
  toggle: _propTypes["default"].func,
  autohide: _propTypes["default"].bool,
  placementPrefix: _propTypes["default"].string,
  delay: _propTypes["default"].oneOfType([_propTypes["default"].shape({
    show: _propTypes["default"].number,
    hide: _propTypes["default"].number
  }), _propTypes["default"].number]),
  modifiers: _propTypes["default"].object,
  offset: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  trigger: _propTypes["default"].string
} : {};
CTooltipPopoverWrapper.defaultProps = {
  show: false,
  hideArrow: false,
  autohide: false,
  delay: DEFAULT_DELAYS,
  toggle: function toggle() {},
  trigger: 'click'
};
var _default = CTooltipPopoverWrapper;
exports["default"] = _default;
module.exports = exports.default;