"use strict";

exports.__esModule = true;
exports["default"] = exports.Context = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CCarouselItem = _interopRequireDefault(require("./CCarouselItem"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCarouselCustom.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Context = _react["default"].createContext({}); //component - CoreUI / CCarouselCustom


exports.Context = Context;

var CCarouselCustom = function CCarouselCustom(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      slide = props.slide;

  var _useState = (0, _react.useState)("right"),
      direction = _useState[0],
      setDirection = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      indicatorClicked = _useState2[0],
      setIndicatorClicked = _useState2[1];

  var fields = (0, _react.useRef)({
    lastProps: null
  }).current;

  var setInterval = function setInterval(properties) {
    if (properties === void 0) {
      properties = props;
    }

    clearInterval();

    if (properties.interval) {
      fields.cycleInterval = window.setInterval(function () {
        properties.next();
      }, parseInt(properties.interval, 10));
    }
  };

  var clearInterval = function clearInterval() {
    window.clearInterval(fields.cycleInterval);
  };

  var hoverStart = function hoverStart() {
    if (props.pause === 'hover') {
      clearInterval();
    }

    if (props.mouseEnter) {
      props.mouseEnter.apply(props, arguments);
    }
  };

  var hoverEnd = function hoverEnd() {
    if (props.pause === 'hover') {
      setInterval();
    }

    if (props.mouseLeave) {
      props.mouseLeave.apply(props, arguments);
    }
  };

  var handleKeyPress = function handleKeyPress(e) {
    if (props.keyboard) {
      if (e.keyCode === 37) {
        props.previous();
      } else if (e.keyCode === 39) {
        props.next();
      }
    }
  };

  var renderItems = function renderItems(carouselItems, className) {
    var slide = props.slide;
    return /*#__PURE__*/_react["default"].createElement("div", {
      role: "listbox",
      className: className,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 70,
        columnNumber: 7
      }
    }, carouselItems.map(function (item, index) {
      var isIn = index === props.activeIndex;
      return _react["default"].cloneElement(item, {
        "in": isIn,
        slide: slide
      });
    }));
  };

  var setState = function setState(oVal, nVal, setF) {
    if (nVal === oVal) return;
    setF(nVal);
  }; //effect


  (0, _react.useEffect)(function () {
    if (props.ride === 'carousel') {
      setInterval();
    }

    document.addEventListener('keyup', handleKeyPress);
    fields._handleKeyPress = handleKeyPress;
    return function cleanup() {
      clearInterval();
      document.removeEventListener('keyup', fields._handleKeyPress);
    };
  }, []);
  (0, _react.useEffect)(function () {
    if (fields.wrappedOnClickFunc) {
      fields.wrappedOnClickFunc();
      setIndicatorClicked(false);
      fields.wrappedOnClickFunc = null;
    }
  }); //render

  setInterval(props);

  if (fields.lastProps) {
    if (fields.lastProps.activeIndex + 1 === props.activeIndex) {
      setState(direction, "right", setDirection);
    } else if (fields.lastProps.activeIndex - 1 === props.activeIndex) {
      setState(direction, "left", setDirection);
    } else if (fields.lastProps.activeIndex > props.activeIndex) {
      setState(direction, indicatorClicked ? "left" : "right", setDirection);
    } else if (fields.lastProps.activeIndex !== props.activeIndex) {
      setState(direction, indicatorClicked ? "right" : "left", setDirection);
    }

    setState(indicatorClicked, false, setIndicatorClicked);
  }

  fields.lastProps = props;
  var outerClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'carousel', slide && 'slide'), cssModule);
  var innerClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])('carousel-inner'), cssModule);
  var children = props.children.filter(function (child) {
    return child !== null && child !== undefined && typeof child !== 'boolean';
  });
  var slidesOnly = children.every(function (child) {
    return child.type === _CCarouselItem["default"];
  });

  if (slidesOnly) {
    return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
      value: {
        direction: direction
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 144,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: outerClasses,
      onMouseEnter: hoverStart,
      onMouseLeave: hoverEnd,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 145,
        columnNumber: 9
      }
    }, renderItems(children, innerClasses)));
  }

  if (children[0] instanceof Array) {
    var _carouselItems = children[0];
    var _controlLeft = children[1];
    var _controlRight = children[2];
    return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
      value: {
        direction: direction
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 158,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: outerClasses,
      onMouseEnter: hoverStart,
      onMouseLeave: hoverEnd,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 159,
        columnNumber: 9
      }
    }, renderItems(_carouselItems, innerClasses), _controlLeft, _controlRight));
  }

  var indicators = children[0];

  var wrappedOnClick = function wrappedOnClick(e) {
    if (typeof indicators.props.onClickHandler === 'function') {
      //this.setState({ indicatorClicked: true }, () => indicators.props.onClickHandler(e));
      fields.wrappedOnClickFunc = function () {
        return indicators.props.onClickHandler(e);
      };

      setIndicatorClicked(true);
    }
  };

  var wrappedIndicators = _react["default"].cloneElement(indicators, {
    onClickHandler: wrappedOnClick
  });

  var carouselItems = children[1];
  var controlLeft = children[2];
  var controlRight = children[3];
  return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
    value: {
      direction: direction
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 183,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: outerClasses,
    onMouseEnter: hoverStart,
    onMouseLeave: hoverEnd,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 184,
      columnNumber: 7
    }
  }, wrappedIndicators, renderItems(carouselItems, innerClasses), controlLeft, controlRight));
};

CCarouselCustom.propTypes = process.env.NODE_ENV !== "production" ? {
  cssModule: _propTypes["default"].object,
  className: _propTypes["default"].string,
  children: _propTypes["default"].array,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  activeIndex: _propTypes["default"].number,
  next: _propTypes["default"].func.isRequired,
  previous: _propTypes["default"].func.isRequired,
  keyboard: _propTypes["default"].bool,
  pause: _propTypes["default"].oneOf(['hover', false]),
  ride: _propTypes["default"].oneOf(['carousel']),
  interval: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].bool]),
  mouseEnter: _propTypes["default"].func,
  mouseLeave: _propTypes["default"].func,
  slide: _propTypes["default"].bool
} : {};
CCarouselCustom.defaultProps = {
  interval: 5000,
  pause: 'hover',
  keyboard: true,
  slide: true
};
var _default = CCarouselCustom;
exports["default"] = _default;