"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _reactTransitionGroup = require("react-transition-group");

var _transitionStatusToCl,
    _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCollapseCustom.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var transitionStatusToClassHash = (_transitionStatusToCl = {}, _transitionStatusToCl[_helper.TransitionStatuses.ENTERING] = 'collapsing', _transitionStatusToCl[_helper.TransitionStatuses.ENTERED] = 'collapse show', _transitionStatusToCl[_helper.TransitionStatuses.EXITING] = 'collapsing', _transitionStatusToCl[_helper.TransitionStatuses.EXITED] = 'collapse', _transitionStatusToCl);

var getTransitionClass = function getTransitionClass(status) {
  return transitionStatusToClassHash[status] || 'collapse';
};

var getHeight = function getHeight(node) {
  return node.scrollHeight;
}; //component - CoreUI / CCollapseCustom


var CCollapseCustom = function CCollapseCustom(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      show = props.show,
      navbar = props.navbar,
      otherProps = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "innerRef", "show", "navbar"]);

  var _useState = (0, _react.useState)(null),
      height = _useState[0],
      setHeight = _useState[1];

  var onEntering = function onEntering(node, isAppearing) {
    setHeight(getHeight(node));
    props.onEntering(node, isAppearing);
  };

  var onEntered = function onEntered(node, isAppearing) {
    setHeight(null);
    props.onEntered(node, isAppearing);
  };

  var onExit = function onExit(node) {
    setHeight(getHeight(node));
    props.onExit(node);
  };

  var onExiting = function onExiting(node) {
    var _unused = node.offsetHeight; // eslint-disable-line no-unused-vars

    setHeight(0);
    props.onExiting(node);
  };

  var onExited = function onExited(node) {
    setHeight(null);
    props.onExited(node);
  }; //render


  var transitionProps = (0, _helper.pick)(otherProps, _helper.TransitionPropTypeKeys);
  var childProps = (0, _helper.omit)(otherProps, _helper.TransitionPropTypeKeys);
  return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.Transition, _extends({}, transitionProps, {
    "in": show,
    onEntering: onEntering,
    onEntered: onEntered,
    onExit: onExit,
    onExiting: onExiting,
    onExited: onExited,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 72,
      columnNumber: 5
    }
  }), function (status) {
    var collapseClass = getTransitionClass(status);
    var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, collapseClass, navbar && 'navbar-collapse'), cssModule);
    var style = height === null ? null : {
      height: height
    };
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, childProps, {
      style: _extends({}, childProps.style, {}, style),
      className: classes,
      ref: props.innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 90,
        columnNumber: 11
      }
    }), children);
  });
};

CCollapseCustom.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, _reactTransitionGroup.Transition.propTypes, {
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  tag: _helper.tagPropType,
  className: _propTypes["default"].node,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  show: _propTypes["default"].bool,
  navbar: _propTypes["default"].bool
}) : {};
CCollapseCustom.defaultProps = _extends({}, _reactTransitionGroup.Transition.defaultProps, {
  show: false,
  appear: false,
  enter: true,
  exit: true,
  tag: 'div',
  timeout: _helper.TransitionTimeouts.Collapse
});
var _default = CCollapseCustom;
exports["default"] = _default;
module.exports = exports.default;