"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CDropdownCustom = require("./CDropdownCustom");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDropdownItem.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CDropdownItem
var CDropdownItem = function CDropdownItem(props) {
  var _omit = (0, _helper.omit)(props, ['toggle']),
      Tag = _omit.tag,
      className = _omit.className,
      cssModule = _omit.cssModule,
      innerRef = _omit.innerRef,
      color = _omit.color,
      divider = _omit.divider,
      header = _omit.header,
      active = _omit.active,
      attributes = _objectWithoutPropertiesLoose(_omit, ["tag", "className", "cssModule", "innerRef", "color", "divider", "header", "active"]);

  var context = (0, _react.useContext)(_CDropdownCustom.Context);

  var onClick = function onClick(e) {
    if (props.disabled || props.header || props.divider) {
      e.preventDefault();
      return;
    }

    if (props.onClick) {
      props.onClick(e);
    }

    if (props.toggle) {
      context.toggle(e);
    }
  };

  var getTabIndex = function getTabIndex() {
    if (props.disabled || props.header || props.divider) {
      return '-1';
    }

    return '0';
  }; //render


  var tabIndex = getTabIndex();
  var role = tabIndex > -1 ? 'menuitem' : undefined;
  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, header ? 'dropdown-header' : divider ? 'dropdown-divider' : 'dropdown-item', active ? 'active' : null, color ? 'bg-' + color : null, {
    disabled: attributes.disabled
  }), cssModule);

  if (Tag === 'button') {
    if (header) {
      Tag = 'h6';
    } else if (divider) {
      Tag = 'div';
    } else if (props.href) {
      Tag = 'a';
    }
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
    type: Tag === 'button' && (attributes.onClick || props.toggle) ? 'button' : undefined
  }, attributes, {
    tabIndex: tabIndex,
    role: role,
    className: classes,
    onClick: onClick,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 72,
      columnNumber: 5
    }
  }));
};

CDropdownItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  color: _propTypes["default"].string,
  href: _propTypes["default"].string,
  divider: _propTypes["default"].bool,
  header: _propTypes["default"].bool,
  active: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  toggle: _propTypes["default"].bool
} : {};
CDropdownItem.defaultProps = {
  tag: 'button',
  toggle: true
};
var _default = CDropdownItem;
exports["default"] = _default;
module.exports = exports.default;