"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _reactPopper = require("react-popper");

var _CDropdownCustom = require("./CDropdownCustom");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDropdownMenu.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CDropdownMenu
var CDropdownMenu = function CDropdownMenu(props) {
  var className = props.className,
      children = props.children,
      cssModule = props.cssModule,
      right = props.right,
      tag = props.tag,
      flip = props.flip,
      modifiers = props.modifiers,
      persist = props.persist,
      innerRef = props.innerRef,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "children", "cssModule", "right", "tag", "flip", "modifiers", "persist", "innerRef"]);

  var noFlipModifier = {
    flip: {
      enabled: false
    }
  };
  var directionPositionMap = {
    up: 'top',
    left: 'left',
    right: 'right',
    down: 'bottom'
  };
  var context = (0, _react.useContext)(_CDropdownCustom.Context); //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'dropdown-menu', {
    'dropdown-menu-right': right,
    'show': context.isOpen
  }), cssModule);
  var Tag = tag;
  var placement;
  var myModifiers = modifiers;

  if (persist || context.isOpen && !context.inNavbar) {
    Tag = _reactPopper.Popper;
    var position1 = directionPositionMap[context.direction] || 'bottom';
    var position2 = right ? 'end' : 'start';
    placement = position1 + "-" + position2; //attributes.component = tag;

    myModifiers = !flip ? _extends({}, modifiers, {}, noFlipModifier) : modifiers;
    /*
    x-placement={attributes.placement}
    */

    return /*#__PURE__*/_react["default"].createElement(Tag, {
      placement: placement,
      modifiers: myModifiers,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 66,
        columnNumber: 7
      }
    }, function (_ref) {
      var ref = _ref.ref,
          style = _ref.style,
          placement = _ref.placement,
          arrowProps = _ref.arrowProps;
      //console.log(style, children);
      return /*#__PURE__*/_react["default"].createElement("div", _extends({}, attributes, {
        tabIndex: "-1",
        role: "menu",
        "aria-hidden": !context.isOpen,
        className: classes,
        ref: innerRef,
        "data-placement": placement,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 73,
          columnNumber: 13
        }
      }), children);
    });
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
    tabIndex: "-1",
    role: "menu"
  }, attributes, {
    "aria-hidden": !context.isOpen,
    className: classes,
    "x-placement": attributes.placement,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 93,
      columnNumber: 5
    }
  }), children);
};

CDropdownMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  right: _propTypes["default"].bool,
  flip: _propTypes["default"].bool,
  modifiers: _propTypes["default"].object,
  persist: _propTypes["default"].bool
} : {};
CDropdownMenu.defaultProps = {
  tag: 'div',
  flip: true
};
var _default = CDropdownMenu;
exports["default"] = _default;
module.exports = exports.default;