"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CImg.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CImg
var CImg = function CImg(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      fluid = props.fluid,
      block = props.block,
      thumbnail = props.thumbnail,
      shape = props.shape,
      align = props.align,
      alt = props.alt,
      src = props.src,
      width = props.width,
      height = props.height,
      placeholderColor = props.placeholderColor,
      active = props.active,
      fluidGrow = props.fluidGrow,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "fluid", "block", "thumbnail", "shape", "align", "alt", "src", "width", "height", "placeholderColor", "active", "fluidGrow"]); // vars


  var isActive = function () {
    //active prop is present in CImgLazy component, here always undefined
    return active !== false;
  }();

  var alignClass = function () {
    if (align === 'center') {
      return 'mx-auto';
    } else if (align === 'right') {
      return 'float-right';
    } else if (align === 'left') {
      return 'float-left';
    }

    return null;
  }(); // render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, alignClass, thumbnail ? 'img-thumbnail' : null, fluid || fluidGrow ? 'img-fluid' : null, fluidGrow ? 'w-100' : null, block ? 'd-block' : null, shape ? shape : null), cssModule);
  return src && isActive ? /*#__PURE__*/_react["default"].createElement("img", _extends({}, attributes, {
    className: classes,
    src: src,
    alt: alt,
    width: width,
    height: height,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 62,
      columnNumber: 7
    }
  })) : /*#__PURE__*/_react["default"].createElement("svg", _extends({}, attributes, {
    className: classes,
    width: width,
    height: height,
    style: {
      'backgroundColor': isActive ? placeholderColor : 'transparent'
    },
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 70,
      columnNumber: 7
    }
  }));
};

CImg.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  src: _propTypes["default"].string,
  alt: _propTypes["default"].string,
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  block: _propTypes["default"].bool,
  fluid: _propTypes["default"].bool,
  fluidGrow: _propTypes["default"].bool,
  active: _propTypes["default"].bool,
  shape: _propTypes["default"].string,
  //oneOf(['', 'rounded']),
  thumbnail: _propTypes["default"].bool,
  align: _propTypes["default"].oneOf(['', 'left', 'right', 'center']),
  placeholderColor: _propTypes["default"].string
} : {};
CImg.defaultProps = {
  placeholderColor: 'transparent'
};
var _default = CImg;
exports["default"] = _default;
module.exports = exports.default;