"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CNavLink = _interopRequireDefault(require("./CNavLink"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CNavItem.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CNavItem
var CNavItem = function CNavItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      active = props.active,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      to = props.to,
      href = props.href,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "active", "linkClassName", "linkProps", "to", "href"]); //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'nav-item', active ? 'active' : false), cssModule);
  var linkClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(linkClassName), cssModule);

  if (!custom) {
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement(_CNavLink["default"], _extends({}, linkProps, {
      className: linkClasses,
      to: to,
      href: href,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 42,
        columnNumber: 9
      }
    }), children));
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 50,
      columnNumber: 7
    }
  }), children);
};

CNavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  children: _propTypes["default"].node,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  active: _propTypes["default"].bool,
  custom: _propTypes["default"].bool,
  linkClassName: _propTypes["default"].string,
  linkProps: _propTypes["default"].object,
  to: _propTypes["default"].string,
  href: _propTypes["default"].string
} : {};
CNavItem.defaultProps = {
  tag: 'li'
};
var _default = CNavItem;
exports["default"] = _default;
module.exports = exports.default;