"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CNavbarBrand.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CNavbarBrand
var CNavbarBrand = function CNavbarBrand(props) {
  var Tag = props.tag,
      className = props.className,
      children = props.children,
      innerRef = props.innerRef,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "children", "innerRef"]);

  var imgSrc = function imgSrc(brand) {
    return brand.src ? brand.src : '';
  };

  var imgWidth = function imgWidth(brand) {
    return brand.width ? brand.width : 'auto';
  };

  var imgHeight = function imgHeight(brand) {
    return brand.height ? brand.height : 'auto';
  };

  var imgAlt = function imgAlt(brand) {
    return brand.alt ? brand.alt : '';
  };

  var navbarBrandImg = function navbarBrandImg(props, classBrand, key) {
    return /*#__PURE__*/_react["default"].createElement("img", {
      src: imgSrc(props),
      width: imgWidth(props),
      height: imgHeight(props),
      alt: imgAlt(props),
      className: classBrand,
      key: key.toString(),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 33,
        columnNumber: 7
      }
    });
  }; //render


  var classes = (0, _classnames["default"])(className, 'navbar-brand');
  var img = [];

  if (props.brand) {
    var classBrand = 'navbar-brand'; //navbar-brand

    img.push(navbarBrandImg(props.brand, classBrand, img.length + 1));
  }

  if (props.full) {
    var _classBrand = 'navbar-brand-full';
    img.push(navbarBrandImg(props.full, _classBrand, img.length + 1));
  }

  if (props.minimized) {
    var _classBrand2 = 'navbar-brand-minimized';
    img.push(navbarBrandImg(props.minimized, _classBrand2, img.length + 1));
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 66,
      columnNumber: 5
    }
  }), children || img);
};

CNavbarBrand.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  children: _propTypes["default"].node,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  brand: _propTypes["default"].any,
  full: _propTypes["default"].any,
  minimized: _propTypes["default"].any
} : {};
CNavbarBrand.defaultProps = {
  tag: 'div'
};
var _default = CNavbarBrand;
exports["default"] = _default;
module.exports = exports.default;