"use strict";

exports.__esModule = true;
exports["default"] = exports.Context = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CPaginationItem = _interopRequireDefault(require("./CPaginationItem"));

var _CPaginationLink = _interopRequireDefault(require("./CPaginationLink"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CPagination.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Context = _react["default"].createContext({}); //component - CoreUI / CPagination


exports.Context = Context;

var CPagination = function CPagination(props) {
  var _classNames;

  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      listClassName = props.listClassName,
      pageFrom = props.pageFrom,
      pageTo = props.pageTo,
      pageMin = props.pageMin,
      pageMax = props.pageMax,
      activePage = props.activePage,
      size = props.size,
      firstButtonHtml = props.firstButtonHtml,
      previousButtonHtml = props.previousButtonHtml,
      nextButtonHtml = props.nextButtonHtml,
      lastButtonHtml = props.lastButtonHtml,
      hideDots = props.hideDots,
      ListTag = props.listTag,
      label = props['aria-label'],
      listProps = props.listProps,
      onClick = props.onClick,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "listClassName", "pageFrom", "pageTo", "pageMin", "pageMax", "activePage", "size", "firstButtonHtml", "previousButtonHtml", "nextButtonHtml", "lastButtonHtml", "hideDots", "listTag", "aria-label", "listProps", "onClick"]);

  var paginationClick = function paginationClick(e, type, n) {
    onClick && onClick(e, type, n);
  }; //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className), cssModule);
  var listClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(listClassName, 'pagination', (_classNames = {}, _classNames["pagination-" + size] = !!size, _classNames)), cssModule);
  var autoChildren;

  if (!custom) {
    var list = [];
    var pageAutoFrom = pageFrom;
    var pageAutoTo = pageTo;

    if (!pageFrom || !pageTo) {
      pageAutoFrom = activePage - 3;
      pageAutoFrom < pageMin ? pageAutoFrom = pageMin : null;
      pageAutoTo = activePage + 3;
      pageAutoTo > pageMax ? pageAutoTo = pageMax : null;
    }

    for (var i = pageAutoFrom; i <= pageAutoTo; i++) {
      list.push( /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
        custom: true,
        key: i,
        active: activePage == i ? true : false,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 75,
          columnNumber: 17
        }
      }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
        type: "number",
        n: i,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 75,
          columnNumber: 83
        }
      }, i)));
    }

    var pagesBefore = pageAutoFrom > pageMin;
    var pagesAfter = pageAutoTo < pageMax;
    autoChildren = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 79,
        columnNumber: 7
      }
    }, pagesBefore && firstButtonHtml ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 80,
        columnNumber: 39
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "first",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 80,
        columnNumber: 63
      }
    }, firstButtonHtml)) : '', pagesBefore && previousButtonHtml ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 81,
        columnNumber: 42
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "previous",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 81,
        columnNumber: 66
      }
    }, previousButtonHtml)) : '', !hideDots && pagesBefore ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 82,
        columnNumber: 33
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "less",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 82,
        columnNumber: 57
      }
    }, "...")) : '', list, !hideDots && pagesAfter ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 84,
        columnNumber: 32
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "more",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 84,
        columnNumber: 56
      }
    }, "...")) : '', pagesAfter && nextButtonHtml ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 85,
        columnNumber: 37
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "next",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 85,
        columnNumber: 61
      }
    }, nextButtonHtml)) : '', pagesAfter && lastButtonHtml ? /*#__PURE__*/_react["default"].createElement(_CPaginationItem["default"], {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 86,
        columnNumber: 37
      }
    }, /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], {
      type: "last",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 86,
        columnNumber: 61
      }
    }, lastButtonHtml)) : '');
  }

  return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
    value: {
      paginationClick: paginationClick
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 92,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    "aria-label": label,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 95,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement(ListTag, _extends({
    className: listClasses
  }, listProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 96,
      columnNumber: 9
    }
  }), autoChildren || children)));
};

CPagination.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  pageMin: _propTypes["default"].number,
  pageMax: _propTypes["default"].number,
  pageFrom: _propTypes["default"].number,
  pageTo: _propTypes["default"].number,
  activePage: _propTypes["default"].number,
  hideDots: _propTypes["default"].bool,
  hideArrows: _propTypes["default"].bool,
  hideDoubleArrows: _propTypes["default"].bool,
  firstButtonHtml: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  previousButtonHtml: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  nextButtonHtml: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  lastButtonHtml: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  size: _propTypes["default"].string,
  listTag: _helper.tagPropType,
  'aria-label': _propTypes["default"].string,
  listClassName: _propTypes["default"].string,
  listProps: _propTypes["default"].object,
  onClick: _propTypes["default"].func
} : {};
CPagination.defaultProps = {
  tag: 'nav',
  listTag: 'ul',
  'aria-label': 'pagination',
  pageMin: 1,
  pageMax: 5,
  activePage: 2,
  hideDots: true,
  firstButtonHtml: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 141,
      columnNumber: 20
    }
  }, "\xAB"),
  previousButtonHtml: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 142,
      columnNumber: 23
    }
  }, "\u2039"),
  nextButtonHtml: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 143,
      columnNumber: 19
    }
  }, "\u203A"),
  lastButtonHtml: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 144,
      columnNumber: 19
    }
  }, "\xBB")
};
var _default = CPagination;
exports["default"] = _default;