"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = require("react");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helper = require("./Shared/helper.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//component - CoreUI / CPortal
var CPortal = function CPortal(props) {
  var fields = (0, _react.useRef)({
    defaultNode: null
  }).current; // effect

  (0, _react.useEffect)(function () {
    return function cleanup() {
      if (fields.defaultNode) {
        document.body.removeChild(fields.defaultNode);
      }

      fields.defaultNode = null;
    };
  }, [fields.defaultNode]); // render

  if (!_helper.canUseDOM) {
    return null;
  }

  if (!props.node && !fields.defaultNode) {
    fields.defaultNode = document.createElement('div');
    document.body.appendChild(fields.defaultNode);
  }

  return _reactDom["default"].createPortal(props.children, props.node || fields.defaultNode);
};

CPortal.propTypes = {
  children: _propTypes["default"].node.isRequired,
  //
  node: _propTypes["default"].any
};
var _default = CPortal;
exports["default"] = _default;
module.exports = exports.default;