"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _iconsReact = require("@coreui/icons-react");

var _CSidebar = require("./CSidebar");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CSidebarNavDropdown.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CSidebarNavDropdown
var CSidebarNavDropdown = function CSidebarNavDropdown(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      innerRef = props.innerRef,
      icon = props.icon,
      fontIcon = props.fontIcon,
      name = props.name,
      show = props.show,
      toggle = props.toggle,
      toggleItem = props.toggleItem,
      route = props.route,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "innerRef", "icon", "fontIcon", "name", "show", "toggle", "toggleItem", "route"]);

  var _useState = (0, _react.useState)(show),
      isOpen = _useState[0],
      setIsOpen = _useState[1];

  var compData = (0, _react.useRef)({}).current; // context

  var context = (0, _react.useContext)(_CSidebar.Context);
  var dropdownMode; // methods

  var onClick = function onClick(e) {
    setIsOpen(!isOpen);
    toggle && toggle(e);
  };

  var onItemClick = function onItemClick(e) {
    toggleItem && toggleItem(e);
  }; // computed


  if (context.dropdownMode) dropdownMode = context.dropdownMode;else dropdownMode = 'openActive'; //watch
  //show

  (0, _react.useMemo)(function () {
    if (compData.nextRender) setIsOpen(show);
  }, [show]); //dropdownMode

  (0, _react.useMemo)(function () {
    var mode = dropdownMode;

    if (mode === 'close') {
      setIsOpen(false);
    } else if (mode === 'closeInactive' && route) {
      setIsOpen(route.fullPath.includes(route));
    } else if (mode === 'openActive' && !isOpen && route) {
      setIsOpen(route.fullPath.includes(route));
    }
  }, [route]); //effect

  (0, _react.useEffect)(function () {
    compData.nextRender = true;
  }, []); //render

  var classes = (0, _classnames["default"])(className, 'c-sidebar-nav-dropdown', isOpen ? 'c-show' : null);
  var iconProps;
  if (typeof icon === 'object') iconProps = icon;else iconProps = {
    name: icon
  };
  var iconClasses = (0, _classnames["default"])('c-sidebar-nav-icon', fontIcon ? fontIcon : null);
  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
    className: classes
  }, attributes, {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 96,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("a", {
    className: "c-sidebar-nav-dropdown-toggle",
    onClick: onClick,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 97,
      columnNumber: 7
    }
  }, icon ? /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, _extends({
    className: "c-sidebar-nav-icon"
  }, iconProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 98,
      columnNumber: 17
    }
  })) : '', fontIcon ? /*#__PURE__*/_react["default"].createElement("i", {
    className: iconClasses,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 99,
      columnNumber: 21
    }
  }) : '', name), /*#__PURE__*/_react["default"].createElement("ul", {
    className: "c-sidebar-nav-dropdown-items",
    onClick: onItemClick,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 102,
      columnNumber: 7
    }
  }, children));
};

CSidebarNavDropdown.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string]),
  className: _propTypes["default"].string,
  children: _propTypes["default"].node,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  name: _propTypes["default"].string,
  icon: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  fontIcon: _propTypes["default"].string,
  show: _propTypes["default"].bool,
  toggle: _propTypes["default"].func,
  toggleItem: _propTypes["default"].func,
  route: _propTypes["default"].string
} : {};
CSidebarNavDropdown.defaultProps = {
  tag: 'li'
};
var _default = CSidebarNavDropdown;
exports["default"] = _default;
module.exports = exports.default;