"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CSwitch.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CSwitch
var CSwitch = function CSwitch(props) {
  var className = props.className,
      innerRef = props.innerRef,
      type = props.type,
      size = props.size,
      disabled = props.disabled,
      color = props.color,
      labelOn = props.labelOn,
      labelOff = props.labelOff,
      variant = props.variant,
      shape = props.shape,
      name = props.name,
      required = props.required,
      value = props.value,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "innerRef", "type", "size", "disabled", "color", "labelOn", "labelOff", "variant", "shape", "name", "required", "value"]);

  var fields = (0, _react.useRef)({
    firstRender: true
  }).current;

  var _useState = (0, _react.useState)(props.defaultChecked || props.checked),
      checked = _useState[0],
      setChecked = _useState[1]; //const [selected, setSelected] = useState([]);
  //effect - update


  (0, _react.useEffect)(function () {
    if (fields.firstRender) return;
    setChecked(props.checked);
  }, [props.checked]);
  (0, _react.useEffect)(function () {
    fields.firstRender = false;
  }, []); //events

  var onChange = function onChange(e) {
    var target = e.target;
    setChecked(target.checked);

    if (props.onChange) {
      props.onChange(e);
    }
  }; //render


  delete attributes.checked;
  delete attributes.defaultChecked;
  delete attributes.onChange;
  /*
  const outlineString = this.outline ? '-outline' : ''
      const outlinedAltString = this.outline === 'alt' ? '-alt' : ''
      return [
        'c-switch form-check-label',
        `c-switch${outlineString}-${this.color}${outlinedAltString}`,
        {
          [`c-switch-${this.size}`]: this.size,
          [`c-switch-${this.shape}`]: this.shape,
          'c-switch-label': this.labelOn || this.labelOff
        }
      ]
  */

  /*
  let outline='';
  switch (variant) {
    case '3d':
        break;
    case 'opposite':
      variant="alt";
      break;
    case '3d-opposite':
        break;
  }
  */
  //console.log(variant);

  var variant2 = ['opposite', 'outline'].indexOf(variant) > -1 ? "-" + variant : '';
  var classes = (0, _classnames["default"])(className, 'c-switch form-check-label', labelOn || labelOff ? 'c-switch-label' : false, size ? "c-switch-" + size : '', shape ? "c-switch-" + shape : '', color ? "c-switch" + variant2 + "-" + color : '', variant == '3d' ? 'c-switch-3d' : '');
  var inputClasses = (0, _classnames["default"])('c-switch-input', 'c-form-check-input');
  var sliderClasses = (0, _classnames["default"])('c-switch-slider'); //classes = "c-switch form-check-label c-switch-label c-switch-opposite c-switch-primary c-switch-lg"

  return /*#__PURE__*/_react["default"].createElement("label", _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 114,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("input", {
    className: inputClasses,
    type: type,
    onChange: onChange,
    checked: checked,
    name: name,
    required: required,
    disabled: disabled,
    value: value,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 115,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: sliderClasses,
    "data-checked": labelOn,
    "data-unchecked": labelOff,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 116,
      columnNumber: 7
    }
  }));
};

CSwitch.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  size: _propTypes["default"].oneOf(['', 'lg', 'sm']),
  shape: _propTypes["default"].oneOf(['', 'pill', 'square']),
  variant: _propTypes["default"].oneOf(['', '3d', '3d-opposite', 'opposite', 'outline']),
  color: _propTypes["default"].string,
  checked: _propTypes["default"].bool,
  labelOn: _propTypes["default"].string,
  labelOff: _propTypes["default"].string,
  type: _propTypes["default"].oneOf(['checkbox', 'radio']),
  value: _propTypes["default"].string,
  defaultChecked: _propTypes["default"].bool,
  name: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  form: _propTypes["default"].any,
  //?
  required: _propTypes["default"].bool,
  onChange: _propTypes["default"].func //label: PropTypes.bool,

  /*
  outline: PropTypes.oneOfType([
    PropTypes.bool,
    PropTypes.string,
    PropTypes.oneOf(['', 'alt'])
  ]),
  */

} : {};
CSwitch.defaultProps = {
  size: '',
  checked: false,
  type: 'checkbox',
  variant: '',
  defaultChecked: false,
  disabled: false,
  required: false //labelOn: 'On',
  //labelOff: 'Off',
  //label: false,
  //outline: false,

};
var _default = CSwitch;
exports["default"] = _default;
module.exports = exports.default;