"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _Slot = _interopRequireDefault(require("./Shared/Slot"));

var _CToastHeader = _interopRequireDefault(require("./CToastHeader"));

var _CToastBody = _interopRequireDefault(require("./CToastBody"));

var _CButtonClose = _interopRequireDefault(require("./CButtonClose"));

var _CFade = _interopRequireDefault(require("./CFade"));

var _CToastModule = _interopRequireDefault(require("./CToast.module.css"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CToast.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CToast
var CToast = function CToast(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      show = props.show,
      header = props.header,
      headerSlot = props.headerSlot,
      autohide = props.autohide,
      closeButton = props.closeButton,
      fade = props.fade,
      transition = props.transition,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "cssModule", "custom", "innerRef", "show", "header", "headerSlot", "autohide", "closeButton", "fade", "transition"]);

  var _useState = (0, _react.useState)(show),
      shown = _useState[0],
      setShown = _useState[1];

  var transitionPar = _extends({}, _CFade["default"].defaultProps, {}, transition, {
    baseClass: fade ? transition.baseClass : '',
    timeout: fade ? transition.timeout : 0
  });

  var timeout;

  var setAutohide = function setAutohide() {
    timeout = setTimeout(function () {
      setShown(false);
    }, autohide);
  };

  var onMouseOver = function onMouseOver() {
    clearTimeout(timeout);
  };

  var onMouseOut = function onMouseOut() {
    if (autohide) setAutohide();
  };

  var onClick = function onClick() {
    setShown(false);
  };

  if (autohide) {
    setAutohide();
  } // render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'toast', 'mytoast'), Object.assign(_CToastModule["default"], cssModule));
  if (!shown) return null;
  if (!custom) return /*#__PURE__*/_react["default"].createElement(_CFade["default"], _extends({}, attributes, transitionPar, {
    tag: Tag,
    className: classes,
    "in": true,
    role: "alert",
    innerRef: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 78,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    "aria-live": "assertive",
    "aria-atomic": "true",
    onMouseOver: onMouseOver,
    onMouseOut: onMouseOut,
    className: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 87,
      columnNumber: 9
    }
  }), /*#__PURE__*/_react["default"].createElement(_CToastHeader["default"], {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 95,
      columnNumber: 11
    }
  }, headerSlot || header ? /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: headerSlot,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 98,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement("strong", {
    className: "mr-auto",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 99,
      columnNumber: 17
    }
  }, header)) : '', closeButton ? /*#__PURE__*/_react["default"].createElement(_CButtonClose["default"], {
    className: "ml-2 mb-1",
    onClick: onClick,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 104,
      columnNumber: 15
    }
  }) : ''), /*#__PURE__*/_react["default"].createElement(_CToastBody["default"], {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 107,
      columnNumber: 11
    }
  }, attributes.children)));
  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    onMouseOver: onMouseOver,
    onMouseOut: onMouseOut,
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 115,
      columnNumber: 5
    }
  }));
};

CToast.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  custom: _propTypes["default"].bool,
  //
  headerSlot: _propTypes["default"].node,
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string, _propTypes["default"].object]),
  show: _propTypes["default"].bool,
  header: _propTypes["default"].string,
  autohide: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].bool]),
  closeButton: _propTypes["default"].bool,
  fade: _propTypes["default"].bool,
  transition: _propTypes["default"].shape(_CFade["default"].propTypes),
  role: _propTypes["default"].string
} : {};
CToast.defaultProps = {
  tag: 'div',
  autohide: 1500,
  closeButton: true,
  fade: true,
  transition: _extends({}, _CFade["default"].defaultProps, {
    unmountOnExit: true
  }),
  role: 'alert'
};
var _default = CToast;
exports["default"] = _default;
module.exports = exports.default;