"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CCard = _interopRequireDefault(require("./CCard"));

var _CProgress = _interopRequireDefault(require("./CProgress"));

var _iconsReact = require("@coreui/icons-react");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CWidgetProgressIcon.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CWidget4
var CWidgetProgressIcon = function CWidgetProgressIcon(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      header = props.header,
      value = props.value,
      icon = props.icon,
      color = props.color,
      invert = props.invert,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "cssModule", "header", "value", "icon", "color", "invert"]);

  var progress = {
    style: '',
    color: color,
    value: value
  };
  var card = {
    style: '',
    bgColor: '',
    icon: icon
  };

  if (invert) {
    progress.style = 'progress-white';
    progress.color = '';
    card.style = 'text-white';
    card.bgColor = 'bg-' + color;
  }

  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, card.style, card.bgColor), cssModule);
  progress.style = (0, _classnames["default"])('progress-xs mt-3 mb-0', progress.style);
  return /*#__PURE__*/_react["default"].createElement(_CCard["default"], _extends({}, attributes, {
    className: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-muted text-right mb-4",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 43,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
    name: card.icon,
    size: "xl",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 44,
      columnNumber: 9
    }
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-value-lg",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 46,
      columnNumber: 7
    }
  }, header), /*#__PURE__*/_react["default"].createElement("small", {
    className: "text-muted text-uppercase font-weight-bold",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 7
    }
  }, children), /*#__PURE__*/_react["default"].createElement(_CProgress["default"], {
    className: progress.style,
    color: progress.color,
    value: progress.value,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 48,
      columnNumber: 7
    }
  }));
};

CWidgetProgressIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  header: _propTypes["default"].string,
  icon: _propTypes["default"].string,
  color: _propTypes["default"].string,
  value: _propTypes["default"].string,
  invert: _propTypes["default"].bool
} : {};
CWidgetProgressIcon.defaultProps = {
  header: '87.500',
  icon: 'cil-people',
  color: 'info',
  value: '25',
  children: 'Visitors',
  invert: false
};
var _default = CWidgetProgressIcon;
exports["default"] = _default;
module.exports = exports.default;